<?php
// no direct access
defined('_JEXEC') or die('Restricted access');

 /*******************************************************************************
    Módulo Indicadores Económicos versión 7
    Versión para Joomla! 1.7.x

    Copyright (C) 2008 - 2013 Juan Iturra Echeverría <jaiturrae@gmail.com>
    Copyright (C) 2011 - 2013 Juan Morales Martínez <jamoralesm@gmail.com>

    http://www.codenova.cl/

    Este programa es software libre. Puede redistribuirlo y/o modificarlo bajo los
    términos de la Licencia Pública General de GNU según es publicada por la Free
    Software Foundation, bien de la versión 2 de dicha Licencia o bien (según su
    elección) de cualquier versión posterior.

    Este programa se distribuye con la esperanza de que sea útil, pero SIN NINGUNA
    GARANTÍA, incluso sin la garantía MERCANTIL implícita o sin garantizar la
    CONVENIENCIA PARA UN PROPÓSITO PARTICULAR. Véase la Licencia Pública General de
    GNU para más detalles.

    Debería haber recibido una copia de la Licencia Pública General junto con este
    programa. Si no ha sido así, escriba a la Free Software Foundation, Inc., en
    675 Mass Ave, Cambridge, MA 02139, EEUU.
*******************************************************************************/

class modIndicadoresHelper{

    public static function mostrar_indicadores_sitio(){

            $config = JFactory::getConfig();

            $cache_tiempo = 10800; //Actualizar cada 3 Horas, 10.800 Segundos

            $cache_archivo = $config->getValue('config.tmp_path').'/'.md5('indicadores').'.dat';

            // Verificar existencia de cache
            if (@file_exists($cache_archivo)) {

                $cache_archivo_tiempo = filemtime($cache_archivo);

                // Chequear que el cache aun este vigente
                if ( (time() - $cache_tiempo) < $cache_archivo_tiempo ) {

                    if(($valores_indicador = modIndicadoresHelper::_leer_archivo_cache($cache_archivo)) === false)

                        return (string) '<pre>No se pudo leer el archivo cache</pre>';

                    else

                        return $valores_indicador;

                 } else {

                    // Si no esta vigente lo actualizamos y leemos de nuevo
                    if ( modIndicadoresHelper::_crear_archivo_cache($cache_archivo) ) {

                        if(($valores_indicador = modIndicadoresHelper::_leer_archivo_cache($cache_archivo)) === false)

                            return (string) '<pre>No se pudo leer el archivo cache</pre>';

                        else

                            return $valores_indicador;

                    } else {

                        return (string) '<pre>No se pudo obtener datos desde CODENOVA</pre>';

                    }
                 }

            } else {

                    // La primera vez se debe crear archivo.
                    if ( modIndicadoresHelper::_crear_archivo_cache($cache_archivo) ) {

                        if(($valores_indicador = modIndicadoresHelper::_leer_archivo_cache($cache_archivo)) === false)

                            return (string) '<pre>No se pudo leer el archivo cache</pre>';

                        else

                            return $valores_indicador;

                    } else {

                        return (string) '<pre>No se pudo obtener datos desde CODENOVA</pre>';

                    }

            }

    }


    private static function _obtener_indicadores ( ) {

        $return = json_decode(file_get_contents('http://codenova.cl/apps/indicadores/json'));

        return is_object($return) ? serialize($return) : FALSE;
    }

    private static function _leer_archivo_cache($cache_archivo){

        if(!file_exists($cache_archivo)) return false;

        if(!is_readable($cache_archivo)) return false;

        $data = unserialize(file_get_contents($cache_archivo));

        return is_object($data) ? $data : FALSE;
    }



    private static function _crear_archivo_cache($cache_archivo){

        if ($datos = modIndicadoresHelper::_obtener_indicadores()){

            //$data = $datos.chr(13).chr(10);

            if(file_exists($cache_archivo))

                if(!is_writable($cache_archivo))
                    return false;

            if(($fp = fopen($cache_archivo,'w')) == false) return false;

            if(fwrite($fp,$datos) === false) return false;

            @fclose($fp);

            return true;

        } else {

            return false;

        }

    }

}
